#include "CreateWorldObjectsVisitor.h"
#include "ScoreBoard.h"


CreateWorldObjectsVisitor::CreateWorldObjectsVisitor(World *n_world) : osg::NodeVisitor(NODE_VISITOR, TRAVERSE_ALL_CHILDREN), worldObjects(), moveableObjects(), transformMatrices()
{
	world = n_world;
	state = 0;
	
	for(int i = 0; i < 8; i++)
		moveableObjects.push_back(0);
}

void CreateWorldObjectsVisitor::apply(osg::Node &currentNode)
{
	//std::cout << "I node: " << currentNode.getName() << std::endl;
	
	traverse(currentNode);
}

void CreateWorldObjectsVisitor::apply(osg::Group &currentGroup)
{
	//std::cout << "I group: " << currentGroup.getName() << std::endl;
	
	switch(state)
	{
		//Normalt
		case 0:
		{
			if((currentGroup.getName() == "moveable") || (currentGroup.getName() == "Moveable"))
			{
				//std::cout << "Detta r moveable-gruppen" << std::endl;
				state = 1;
			}
	
			if((currentGroup.getName() == "static") || (currentGroup.getName() == "Static"))
			{
				//std::cout << "Detta r static-gruppen" << std::endl;
				state = 2;
			}
	
			traverse(currentGroup);
	
			if((currentGroup.getName() == "moveable") || (currentGroup.getName() == "Moveable"))
			{
				//std::cout << "Frdig med traversering av moveable-gruppen" << std::endl;
				state = 0;
			}
	
			if((currentGroup.getName() == "static") || (currentGroup.getName() == "Static"))
			{
				//std::cout << "Frdig med traversering av static-gruppen" << std::endl;
				state = 0;
			}
			
			break;
		}
		
		//Fortfarande i moveable- eller static-gruppen
		case 1:
		case 2:
		case 3:
		{
			//Fortstt nert i trdet och "ignorera" gruppen
			//std::cout << "Grupp i objekt, fortstter traverseringen.." << std::endl;
			traverse(currentGroup);
			break;
		}
	}

}

void CreateWorldObjectsVisitor::apply(osg::Transform &currentTransform)
{
	//std::cout << "I transform: " << currentTransform.getName() << std::endl;
	
	osg::MatrixTransform *moveableMatrixTransform;
	moveableMatrixTransform = currentTransform.asMatrixTransform();
	osg::MatrixTransform *staticMatrixTransform = moveableMatrixTransform;
			
	//Kollar om det r en osg::MatrixTransform vi r i
	if(moveableMatrixTransform != 0)
	{
		//std::cout << "Detta r en MatrixTransform!" << std::endl;
	
		switch(state)
		{
			case 0:
			{
				//std::cout << "Visitorn ska varken vara i moveable eller static-grupperna nu" << std::endl;
				break;
			}
		
			//moveable
			case 1:
			{
				//Detta objekt ska lggas till som kropp och kollisionsgeometri
				//i fysikmotorn med sin transformations som position, rotation
				//etc och sedan registreras hos spellogiken som ett Moveable
				//objekt
			

				//std::cout << "Moveable object descriptionList: ";
	
				/*for(unsigned int i = 0; i < currentTransform.getNumDescriptions(); i++)
					std::cout << currentTransform.getDescription(i) << " ";

				std::cout << std::endl;*/

				parseDescriptionList(currentTransform.getDescriptions());
			
				//Lgger till denna transformationen till listan
				transformMatrices.push_back(moveableMatrixTransform->getMatrix());
				//D vi nu r i en MatrixTransform moveable-gruppen p versta
				//nivn innebr det att detta r brjan av ett objekt och denna
				//transformation kommer att vara dess referenspunkt. Vrt att
				//nmna r att alla grupper ignoreras.
				
				//Nu ska alla underliggande geoders boundingboxar rknas ihop
				//fr att skapa en total boundingbox fr hela objektet
				state = 3;
				firstPart = true;
				traverse(currentTransform);
				
				//BoundingBoxen r nu frdigberknad
				state = 1;

				//Tar bort denna transformationen frn listan
				transformMatrices.pop_back();
				
				//Nu har vi Boundingboxen fr objektet som r :
				/*std::cout << "Moveable object BoundingBox: " << std::endl;
				std::cout << "xMin: " << xMin << std::endl;
				std::cout << "xMax: " << xMax << std::endl;
				std::cout << "yMin: " << yMin << std::endl;
				std::cout << "yMax: " << yMax << std::endl;
				std::cout << "zMin: " << zMin << std::endl;
				std::cout << "zMax: " << zMax << std::endl;*/
							
			
				
						
				osg::Matrix osgMatrix;
				osgMatrix = moveableMatrixTransform->getMatrix();

				/*std::cout << "osgMatrix:";
				for(int i = 0; i < 16; i++)
				{
					if((i % 4) == 0)
						std::cout << std::endl;
					
					std::cout << osgMatrix.ptr()[i] << " ";
				}
				std::cout << std::endl;*/



				//Skapar ett MoveableObject p heapen
				MoveableObject *moveableObject; 
				
				//Lter massan vara 1.0kg och stter viktfrdelningen till en
				//lda eller sfr med storleken av geodens boundingbox inrknat
				//dess skalning i den ovanliggande transformationen
				//Lgger till moveableObject till listan med MoveableObjects
				//beroende p namn
				
				if(
					(moveableMatrixTransform->getName() == "Ball 0")||
					(moveableMatrixTransform->getName() == "Ball 1")||
					(moveableMatrixTransform->getName() == "Ball 2")||
					(moveableMatrixTransform->getName() == "Ball 3")||
					(moveableMatrixTransform->getName() == "Ball 4")||
					(moveableMatrixTransform->getName() == "Ball 5")||
					(moveableMatrixTransform->getName() == "Ball 6")||
					(moveableMatrixTransform->getName() == "Ball 7"))
				{
					//SKAPAR EN BOLL!
					
					dBodyID moveableBody;
					dMass moveableMass;
					dGeomID moveableGeom;
					
					//Skapar en kropp
					moveableBody = dBodyCreate(world->getPhysicsWorld());
				
					//SFR
					
					osg::BoundingSphere boundingSphere;
					boundingSphere = moveableMatrixTransform->getBound();
					
					dMassSetSphereTotal(&moveableMass, 0.05,
						(xMax - xMin) / 2);
						
						
					//Skapar en kollisionsgeometri fr objektet och stter dess
					moveableGeom = dCreateSphere(world->getPhysicsSpace(),
						(xMax - xMin) / 2);
					
					//SFR
					
					
					//Stter den ovan definerade massan till kroppen
					dBodySetMass(moveableBody, &moveableMass);
					//kopplar ihop kroppen med kollisionsgeometrin
					dGeomSetBody(moveableGeom, moveableBody);	
					
					//Stter kroppens initiala centrum-position och rotation baserat
					//p geodens ovanliggande transformation
					dGeomSetPosition(moveableGeom,
						osgMatrix.ptr()[12],
						osgMatrix.ptr()[13],
						osgMatrix.ptr()[14]);
		
					PhysicsObject *physicsObject = new PhysicsObject(
													moveableGeom,
													world->getPhysicsWorld(),
													world->getPhysicsSpace(),
													world->getPhysicsGroup());				
					moveableObject = new Ball(physicsObject, moveableMatrixTransform);
					moveableObjects.push_back(moveableObject);
					
				}
				else if((moveableMatrixTransform->getName() == "Player 0") ||
						(moveableMatrixTransform->getName() == "Player 1") ||
						(moveableMatrixTransform->getName() == "Player 2") ||
						(moveableMatrixTransform->getName() == "Player 3") ||
						(moveableMatrixTransform->getName() == "Player 4") ||
						(moveableMatrixTransform->getName() == "Player 5") ||
						(moveableMatrixTransform->getName() == "Player 6") ||
						(moveableMatrixTransform->getName() == "Player 7"))
				{
					//SKAPAR EN SPELARE!
					
					dBodyID moveableBody;
					dMass moveableMass;
					dGeomID moveableGeom;
					
					//Skapar en kropp
					moveableBody = dBodyCreate(world->getPhysicsWorld());
				
					//BOX
					dMassSetBoxTotal(&moveableMass, 95.0,
						xMax - xMin,
						yMax - yMin,
						zMax - zMin);
						
					//Skapar en kollisionsgeometri fr objektet och stter dess
					moveableGeom = dCreateBox(world->getPhysicsSpace(),
						xMax - xMin,
						yMax - yMin,
						zMax - zMin);
					
					//BOX
					
					
					//Stter den ovan definerade massan till kroppen
					dBodySetMass(moveableBody, &moveableMass);
					//kopplar ihop kroppen med kollisionsgeometrin
					dGeomSetBody(moveableGeom, moveableBody);
					
					//Stter kroppens initiala centrum-position och rotation baserat
					//p geodens ovanliggande transformation
					dGeomSetPosition(moveableGeom,
						osgMatrix.ptr()[12],
						osgMatrix.ptr()[13],
						osgMatrix.ptr()[14]);
						
					dJointID j1 = dJointCreateAMotor(world->getPhysicsWorld(), 0);
					dJointID j2 = dJointCreateAMotor(world->getPhysicsWorld(), 0);
					//Hindrar rotation runt x-axeln
					dJointAttach(j1, moveableBody, 0);
					dJointSetAMotorMode(j1, dAMotorEuler);
					dJointSetAMotorAxis(j1, 0, 1, 0, 0, 1);
					dJointSetAMotorAxis(j1, 2, 2, 1, 0, 0);
					dJointSetAMotorParam(j1, dParamLoStop3,		-0.1);
					dJointSetAMotorParam(j1, dParamHiStop3,		0.1);
					dJointSetAMotorParam(j1, dParamFMax3,		0.001);
					dJointSetAMotorParam(j1, dParamBounce3,		0.0);
					dJointSetAMotorParam(j1, dParamVel3,		0.0);
					dJointSetAMotorParam(j2, dParamFudgeFactor,	0.5);
					
					//Hindrar rotation runt y-axeln
					dJointAttach(j2, moveableBody, 0);
					dJointSetAMotorMode(j2, dAMotorEuler);
					dJointSetAMotorAxis(j2, 0, 1, 0, 0, 1);
					dJointSetAMotorAxis(j2, 2, 2, 0, 1, 0);						
					dJointSetAMotorParam(j2, dParamLoStop3, 	-0.1);
					dJointSetAMotorParam(j2, dParamHiStop3,		0.1);
					dJointSetAMotorParam(j2, dParamFMax3,		0.001);
					dJointSetAMotorParam(j2, dParamBounce3,		0.0);
					dJointSetAMotorParam(j2, dParamVel3,		0.0);
					dJointSetAMotorParam(j2, dParamFudgeFactor,	0.5);

					
					
					PhysicsObject *physicsObject = new PhysicsObject(
													moveableGeom,
													world->getPhysicsWorld(),
													world->getPhysicsSpace(),
													world->getPhysicsGroup());	
					moveableObject = new TennisPlayer(physicsObject, moveableMatrixTransform);		
									
					ScoreBoard *sb = world->getScoreBoard();
					sb->addPlayer( (moveableObject->asTennisPlayer()) );
					if((moveableMatrixTransform->getName() == "Player 0"))
					{	
						moveableObjects[0] = moveableObject;
						if(moveableObjects[0]!=0)
							moveableObjects[0]->asTennisPlayer()->setName("Server  ");
						
					}
					else if((moveableMatrixTransform->getName() == "Player 1"))
					{	
						moveableObjects[1] = moveableObject;
						if(moveableObjects[1]!=0)
							moveableObjects[1]->asTennisPlayer()->setName("Player 1");
						
					}
					else if((moveableMatrixTransform->getName() == "Player 2"))
					{	
						moveableObjects[2] = moveableObject;
						if(moveableObjects[2]!=0)
							moveableObjects[2]->asTennisPlayer()->setName("Player 2");
						
					}									
					else if((moveableMatrixTransform->getName() == "Player 3"))
					{	
						moveableObjects[3] = moveableObject;
						if(moveableObjects[3]!=0)
							moveableObjects[3]->asTennisPlayer()->setName("Player 3");
						
					}
					else if((moveableMatrixTransform->getName() == "Player 4"))
					{	
						moveableObjects[4] = moveableObject;
						if(moveableObjects[4]!=0)
							moveableObjects[4]->asTennisPlayer()->setName("Player 4");
						
					}
					else if((moveableMatrixTransform->getName() == "Player 5"))
					{	
						moveableObjects[5] = moveableObject;
						if(moveableObjects[5]!=0)
							moveableObjects[5]->asTennisPlayer()->setName("Player 5");
						
					}
					else if((moveableMatrixTransform->getName() == "Player 6"))
					{	
						moveableObjects[6] = moveableObject;
						if(moveableObjects[6]!=0)
							moveableObjects[6]->asTennisPlayer()->setName("Player 6");
						
					}
					else if((moveableMatrixTransform->getName() == "Player 7"))
					{	
						moveableObjects[7] = moveableObject;
						if(moveableObjects[7]!=0)
							moveableObjects[7]->asTennisPlayer()->setName("Player 7");
						
					}				
				}
				else
				{
					//SKAPAR ETT ANNAT RRLIGT OBJEKT!
					
					dBodyID moveableBody;
					dMass moveableMass;
					dGeomID moveableGeom;
					//BOX
				
					//Skapar en kropp
					moveableBody = dBodyCreate(world->getPhysicsWorld());
				
					dMassSetBoxTotal(&moveableMass, 100.0,
						xMax - xMin,
						yMax - yMin,
						zMax - zMin);
						
					//Skapar en kollisionsgeometri fr objektet och stter dess
					moveableGeom = dCreateBox(world->getPhysicsSpace(),
						xMax - xMin,
						yMax - yMin,
						zMax - zMin);
					
					//BOX
					
					
					//Stter den ovan definerade massan till kroppen
					dBodySetMass(moveableBody, &moveableMass);
					//kopplar ihop kroppen med kollisionsgeometrin
					dGeomSetBody(moveableGeom, moveableBody);
					
					//Stter kroppens initiala centrum-position och rotation baserat
					//p geodens ovanliggande transformation
					dGeomSetPosition(moveableGeom,
						osgMatrix.ptr()[12],
						osgMatrix.ptr()[13],
						osgMatrix.ptr()[14]);
					
					PhysicsObject *physicsObject = new PhysicsObject(
													moveableGeom,
													world->getPhysicsWorld(),
													world->getPhysicsSpace(),
													world->getPhysicsGroup());
																										
					moveableObject = new MoveableObject(physicsObject, moveableMatrixTransform);
					moveableObjects.push_back(moveableObject);
				}
				
				//Lgger till moveableObject till listan med WorldObjects
				worldObjects.push_back(moveableObject);
				break;
			}
		
			//static
			case 2:
			{
				//Detta objekt ska lggas till som enbart kollisionsgeometri med
				//sin transformation som position, rotation, etc och sedan
				//registeras hos spellogiken som ett WorldObject

				//std::cout << "Static object descriptionList: ";
	
				/*for(unsigned int i = 0; i < currentTransform.getNumDescriptions(); i++)
					std::cout << currentTransform.getDescription(i) << " ";

				std::cout << std::endl;*/

transformMatrices.push_back(moveableMatrixTransform->getMatrix());			
				//Nu ska alla underliggande geoders boundingboxar rknas ihop
				//fr att skapa en total boundingbox fr hela objektet
				state = 3;
				firstPart = true;
				traverse(currentTransform);
				
				//BoundingBoxen r nu frdigberknad
				state = 2;

				//Tar bort denna transformationen frn listan
				transformMatrices.pop_back();
				
				//Boundingbox fr objektet:
				/*std::cout << "Static object BoundingBox: " << std::endl;
				std::cout << "xMin: " << xMin << std::endl;
				std::cout << "xMax: " << xMax << std::endl;
				std::cout << "yMin: " << yMin << std::endl;
				std::cout << "yMax: " << yMax << std::endl;
				std::cout << "zMin: " << zMin << std::endl;
				std::cout << "zMax: " << zMax << std::endl;*/

			
				dGeomID staticGeom;
			
				//Skapar en kollisionsgeometri fr objektet och stter dess
				//storlek till objektets boundingbox
				staticGeom = dCreateBox(world->getPhysicsSpace(),
					xMax - xMin,
					yMax - yMin,
					zMax - zMin);

				osg::Matrix osgMatrix;
				osgMatrix = staticMatrixTransform->getMatrix();

				/*std::cout << "osgMatrix:";
				for(int i = 0; i < 16; i++)
				{
					if((i % 4) == 0)
						std::cout << std::endl;
					
					std::cout << osgMatrix.ptr()[i] << " ";
				}
				std::cout << std::endl;*/

				//Stter kroppens initiala centrum-position och rotation baserat
				//p geodens ovanliggande transformation
				dGeomSetPosition(staticGeom,
					osgMatrix.ptr()[12],
					osgMatrix.ptr()[13],
					osgMatrix.ptr()[14]);
				

				//dMatrix3 odeRotMatrix;
				
				//odeRotMatrix[0] = osgMatrix.ptr()[0];
				//odeRotMatrix[1] = osgMatrix.ptr()[4];
				//odeRotMatrix[2] = osgMatrix.ptr()[8];
				//odeRotMatrix[4] = osgMatrix.ptr()[1];
				//odeRotMatrix[5] = osgMatrix.ptr()[5];
				//odeRotMatrix[6] = osgMatrix.ptr()[9];
				//odeRotMatrix[8] = osgMatrix.ptr()[2];
				//odeRotMatrix[9] = osgMatrix.ptr()[6];
				//odeRotMatrix[10] = osgMatrix.ptr()[10];
				
				//dGeomSetRotation(staticGeom, odeRotMatrix);
				
				//Skapar ett WorldObject p heapen
				PhysicsObject *physicsObject = new PhysicsObject(staticGeom, world->getPhysicsWorld(),world->getPhysicsSpace(),world->getPhysicsGroup());
				WorldObject *staticObject = new WorldObject(physicsObject, staticMatrixTransform);

				//Lgger till staticObject till listan med WorldObjects
				worldObjects.push_back(staticObject);
				break;
			}
		
			//Om det r i ett objekt dr bounding-boxen berknas
			case 3:
			{
				//Lgger till den hr transformations-matrisen i listan och
				//traverserar vidare
					transformMatrices.push_back(moveableMatrixTransform->getMatrix());
				traverse(currentTransform);
				
				//Tar bort denna transformationen frn listan
				transformMatrices.pop_back();
				break;
			}
		}
	
	}
	else
		std::cout << "Endast Transforms av typen MatrixTransforms r tilltna!" << std::endl;
}

void CreateWorldObjectsVisitor::apply(osg::Geode &currentGeode)
{
	//std::cout << "I geode: " << currentGeode.getName() << std::endl;
	
	if(state == 3)
	{
		osg::Matrix totalTransform;

		for(unsigned int j = 0; j < transformMatrices.size(); j++)
			totalTransform.preMult(transformMatrices[j]);
		
		const osg::BoundingBox boundingBox = currentGeode.getBoundingBox();
		for(unsigned int i = 0; i < 7; i++)
		{
			osg::Vec3 corner;

			corner = boundingBox.corner(i);
		
				
			//Om detta r frsta hrnet i frsta objektet stts dess
			//center-x, y z - punkter till initiala xMin, xMax, yMin, yMax,
			//zMin, zMax d boundingboxen garanterat kommer att hamna utanfr
			//den
			if(firstPart)
			{
				osg::Vec3 center = boundingBox.center();
				
				//center = totalTransform * center;
				center = center + totalTransform.getTrans();
			
				xMin = center.x();
				xMax = center.x();
				yMin = center.y();
				yMax = center.y();
				zMin = center.z();
				zMax = center.z();
			
				firstPart = false;
			}
		
			//corner = totalTransform * corner;
			
			//Applicera frst skalningen
			corner[0] = corner[0] * totalTransform.getScale()[0];
			corner[1] = corner[1] * totalTransform.getScale()[1];
			corner[2] = corner[2] * totalTransform.getScale()[2];
			//Flytta sedan spektaklet
			corner = corner + totalTransform.getTrans();
			
			//std::cout << "corner.z(): " << corner.z() << std::endl;
			
			//Kollar om detta hrn r utanfr boundingboxen fr detta
			//moveable/static-objekt och frstorar den isf
			if(corner.x() < xMin)
				xMin = corner.x();

			if(corner.x() > xMax)
				xMax = corner.x();

			if(corner.y() < yMin)
				yMin = corner.y();

			if(corner.y() > yMax)
				yMax = corner.y();

			if(corner.z() < zMin)
				zMin = corner.z();

			if(corner.z() > zMax)
				zMax = corner.z();
		}

	}
	
	//std::cout << "Done with geode!" << std::endl;
	//traverse(currentGeode);
}


int CreateWorldObjectsVisitor::getNumMoveableObjects(void)
{
	return moveableObjects.size();
}

MoveableObject **CreateWorldObjectsVisitor::getMoveableObjects(void)
{
	MoveableObject **moveableObjectPtrs = new (MoveableObject *)[moveableObjects.size()];
	
	for(unsigned int i = 0; i < moveableObjects.size(); i++)
		moveableObjectPtrs[i] = moveableObjects[i];

	return moveableObjectPtrs;
}

int CreateWorldObjectsVisitor::getNumWorldObjects(void)
{
	return worldObjects.size();
}

WorldObject **CreateWorldObjectsVisitor::getWorldObjects(void)
{
	WorldObject **worldObjectPtrs = new (WorldObject *)[worldObjects.size()];
	
	for(unsigned int i = 0; i < worldObjects.size(); i++)
		worldObjectPtrs[i] = worldObjects[i];

	return worldObjectPtrs;
}

void CreateWorldObjectsVisitor::parseDescriptionList(std::vector<std::string> &descriptionList)
{
	for(unsigned int i = 0; i < descriptionList.size(); i++)
	{
		std::string lowerString = std::string(descriptionList[i]);
		
		
		//std::transform (descriptionList[i].begin(),descriptionList[i].end(), lowerString.begin(), tolower);
		
	
		std::cout << "lowerString: " << lowerString << std::endl;
	}

}
