#ifndef _MT_CREATEWORLDVISITOR_
#define _MT_CREATEWORLDVISITOR_

#include <iostream>
#include <cstdlib>
#include <osg/MatrixTransform>
#include <osg/Matrix>
#include <osg/Geode>

#include "World.h"
#include "TennisPlayer.h"
#include "Ball.h"
#include "PhysicsObject.h"

class CreateWorldObjectsVisitor: public osg::NodeVisitor
{
	public:
		CreateWorldObjectsVisitor(World *n_world);
		
		virtual void apply(osg::Node &currentNode);
		virtual void apply(osg::Group &currentGroup);
		virtual void apply(osg::Transform &currentTransform);
		virtual void apply(osg::Geode &currentGeode);
		
		int getNumMoveableObjects();
		MoveableObject **getMoveableObjects();
		
		int getNumWorldObjects();
		WorldObject **getWorldObjects();
		

	private:
		World *world;
		int state; // 0 = normal, 1 = moveable, 2 = sttic, 3 = boundingbox
		std::vector<WorldObject *> worldObjects;
		std::vector<MoveableObject *> moveableObjects;
		std::vector<osg::Matrix> transformMatrices;
		
		float xMin;
		float xMax;
		float yMin;
		float yMax;
		float zMin;
		float zMax;
		
		bool firstPart;
		
		int otherMoveableObjectPos;
		
		void parseDescriptionList(std::vector<std::string> &descriptionList);
};
#endif
