#include "IOHandler.h"
#include "MortalTennis.h"

/////////////////////////////////
//////// KeyEventHandler ////////
/////////////////////////////////

KeyEventHandler::KeyEventHandler(RakClientInterface *rci, osgProducer::Viewer *n_viewer, Producer::RenderSurface *rs, MortalTennis *mt) //konstruktor
{
	rakClientInterface = rci;
	viewer = n_viewer;
	renderSurface = rs;
	altLeft = false;
	mortalT = mt;
	countR = 0;
	countT = 1;
}

bool KeyEventHandler::handle(const osgGA::GUIEventAdapter& ea,osgGA::GUIActionAdapter& aa)
{
	switch(ea.getEventType())
	{
		case(osgGA::GUIEventAdapter::KEYDOWN):
		{
			switch(ea.getKey())
			{
				case osgGA::GUIEventAdapter::KEY_Escape:
										
					std::cout<<"Tells the viewer it's done, should make the application exit!"<<std::endl;
					
					viewer->setDone(true);
					
					return true;
					
				break;
				
				case 'r':
				case 'R':
					if(countR == 0)
					{
						mortalT->setTopRightCameraType(SCOREBOARD);	
						countR++;
					}
					else if (countR == 1)
					{
						mortalT->setTopRightCameraType(OVERVIEW_A);	
						countR++;
					}
					else if (countR == 2)
					{
						mortalT->setTopRightCameraType(OVERVIEW_B);	
						countR++;
					}
					else if (countR == 3)
					{
						mortalT->setTopRightCameraType(OVERVIEW_C);	
						countR++;
					}
					else if (countR == 4)
					{
						mortalT->setTopRightCameraType(NOCAMERA);		
						countR = 0;
					}
				
				break;
				
				case 't':
				case 'T':
					if(countT == 0)
					{
						mortalT->setPlayerView(EYEVIEW);	
						countT++;
					}
					else if (countT == 1)
					{
						mortalT->setPlayerView(BACKVIEW);	
						countT = 0;
					}
					
				break;
				
				
				case 'y':
				case 'Y':
					mortalT->musicOnOff();
				break;
				
				
				
				case osgGA::GUIEventAdapter::KEY_Alt_L:
					altLeft = true;
				break;
				
				case osgGA::GUIEventAdapter::KEY_Return:
					if(altLeft) 
					{
						if(renderSurface->isFullScreen())
						{
							renderSurface->useBorder(true);
							renderSurface->setWindowRectangle(500,150,640,480);
							renderSurface->fullScreen(false);
						}
						else
						{
							renderSurface->useBorder(false);
							renderSurface->fullScreen(true);
						}
						altLeft = false;
					}
				break;
				
			}	
		}
		

		case(osgGA::GUIEventAdapter::KEYUP):
		{
		}
		
		default:
		return false;
	}
}
