#include "MoveableObject.h"

MoveableObject::MoveableObject(PhysicsObject *n_physicsObject, osg::MatrixTransform *n_graphicsObject) : WorldObject(n_physicsObject, n_graphicsObject)
{
	
}
MoveableObject::~MoveableObject()
{
	
}
void MoveableObject::collision(MoveableObject *mo, dContact thisContact)
{
	//printf("I moveable object collision.\n");
	
	dGeomID own_object = getPhysicsObject();
	dGeomID other_object = mo->getPhysicsObject();
	
	dJointID collisionJoint;
	
	//dContact thisContact;
		
	thisContact.surface.mode = dContactBounce;
	thisContact.surface.mu = friction * mo->getFriction();
	//thisContact.surface.mu2 = 1000;
	thisContact.surface.bounce = bounce * mo->getBounce();
	thisContact.surface.bounce_vel = 0;	
	
	collisionJoint = dJointCreateContact(physicsObject->getWorld(), physicsObject->getGroup(), &thisContact);
		
	dJointAttach(collisionJoint, dGeomGetBody(own_object), dGeomGetBody(other_object));
	
}
void MoveableObject::update()
{
	//printf("Updating graphics object from physics engine.\n");
	//Uppdatera vrden frn fysikmotor

	//Uppdatera Position
	const dReal *position = dGeomGetPosition(physicsObject->getObject());
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[12] = position[0];//x
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[13] = position[1];//y
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[14] = position[2];//z
	
	//Uppdatera Rotation
	const dReal *rotation = dGeomGetRotation(physicsObject->getObject());
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[0] = rotation[0];//RowCol(1,1)
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[1] = rotation[4];//RowCol(1,2)
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[2] = rotation[8];//RowCol(1,3)
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[4] = rotation[1];//RowCol(2,1)
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[5] = rotation[5];//RowCol(2,2)
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[6] = rotation[9];//RowCol(2,3)
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[8] = rotation[2];//RowCol(3,1)
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[9] = rotation[6];//RowCol(3,2)
	((osg::Matrix::value_type*) graphicsObject->getMatrix().ptr())[10] = rotation[10];//RowCol(3,3)
	
	
	osg::Matrix scaleMatrix;
	scaleMatrix.makeScale(scale);
	
	//Applicerar skalningen som lstes in frn osg-trdet frn brjan
	graphicsObject->preMult(scaleMatrix);

	
}

