#ifndef _MT_NETWORK_
#define _MT_NETWORK_

#include <raknet/RakClientInterface.h>
#include <raknet/RakNetworkFactory.h>
#include <raknet/RakServerInterface.h>
#include <raknet/PacketEnumerations.h>

#include <iostream>
#include <unistd.h>

#include <osg/Vec3>
#include <osg/Matrix>
#include <osgProducer/Viewer>

#include <ode/ode.h>

#include "World.h"
#include "TennisPlayer.h"


#define MAX_PLAYERS 8 

class MoveCameraManipulator;

///////////////////////////////
//////// ClientNetwork ////////
///////////////////////////////

class ClientNetwork
{
	private:
	
					
	public:
	
	ClientNetwork(World *w, osgProducer::Viewer *v, MoveCameraManipulator *n_mc, ScoreBoard *sb);
	
	bool init(char *serverName);
	RakClientInterface* getInterface();
	osg::Matrix getTestCamera(); //test, ska bort sen
};



///////////////////////////////
//////// ServerNetwork ////////
///////////////////////////////

class ServerNetwork
{
	private:

	public:
	ServerNetwork(World *w, ScoreBoard *sb);
	bool init();
	void sendTransMatrices(char* data, int bytes);
	void sendHitsAndKills(char *data, int bytes);
	RakServerInterface* getInterface();
	void removeFromList(Packet *packet);
};

void sendPlaySound(char *soundData, int bytes);


#endif
