#include "ScoreBoard.h"
#include "TennisPlayer.h"
#include <iostream>

ScoreBoard::ScoreBoard()
{
	players = 0;
	
	geode  = new osg::Geode;	
	
	rawText = new char[CHARSPACE * 2];
	for(int i = 0; i < CHARSPACE * 2; i++)
		rawText[i] = '\0';
	
	currentPtr = rawText;
	previousPtr = rawText + CHARSPACE;
	
	changed = false;
	
	text = new osgText::Text;
	text->setFont("../fonts/mickey.ttf");
	text->setColor(osg::Vec4(1.0f,1.0f,0.0f,1.0f)); //gult
	text->setCharacterSize(20.0f);
	text->setPosition(osg::Vec3(59,50,0));
	//text->setAutoRotateToScreen(true);

	text->setLayout(osgText::Text::LEFT_TO_RIGHT);

	geode->addDrawable(text);
}


ScoreBoard::~ScoreBoard()
{
	delete rawText;
}

char *ScoreBoard::getText()
{
	return currentPtr;
}

void
ScoreBoard::addPlayer(TennisPlayer *new_player)
{
	if( new_player != NULL)
	{
		if(players<8)
		{
			player[players] = new_player;
			players++;
		}
	}
	
	update(-1);
	
}

void
ScoreBoard::update(int playerNr)
{
	char *tempPtr;
	
	tempPtr = currentPtr;
	currentPtr = previousPtr;
	previousPtr = tempPtr;

	sprintf(currentPtr,"    MortalTennis\nname      kills hits\n");
	sprintf(currentPtr,"%s-----      ---- ----\n",currentPtr);
	for(int i = 1; i < players-1; i++)
	{
			if(playerNr == i)
			{
				sprintf(currentPtr,"%s%s *   %d    %d\n",
					currentPtr,
					player[i]->getName(),
					player[i]->getKills(),
					player[i]->getHits());
			}
			else
			{
				sprintf(currentPtr,"%s%s     %d    %d\n",
					currentPtr,
					player[i]->getName(),
					player[i]->getKills(),
					player[i]->getHits());
			}
	}
	
	if(strcmp(rawText, rawText + CHARSPACE) != 0)
	{
		changed = true;
		text->setText(currentPtr);
		
		//printf("ScoreBoard has changed!\n");
		
		//printf(currentPtr);
	}
}

bool ScoreBoard::hasChanged(void)
{
	if(changed)
	{
		changed = false;
		return true;
	}
	
	return false;
}

osg::Geode *ScoreBoard::getGeode()
{
	return geode;
}

int ScoreBoard::getNumPlayers(void)
{
	return players;
}

void ScoreBoard::setChanged(bool n_changed)
{
	changed = n_changed;
}
