#include <osg/Vec3>
#include <osg/Matrix>
#include <osg/Node>
#include <osg/Timer>
#include <osgGA/MatrixManipulator>
#include <osgDB/ReadFile>
#include <osgUtil/Optimizer>
#include <osgProducer/Viewer>
#include <osgText/Font>
#include <osgText/Text>

#define CHARSPACE 200

class TennisPlayer;

class ScoreBoard
{
	protected:
		TennisPlayer *player[8];
		int players;
		char *rawText;
		
		char *currentPtr;
		char *previousPtr;
		
		osg::Geode *geode;
		osgText::Text* text;
		
		bool changed;
		
		std::string *testString;
		
		int playerNr;

	public:
		ScoreBoard();
		~ScoreBoard();
		
		char *getText();
		osg::Geode *getGeode();
		void addPlayer(TennisPlayer *player);
		int getNumPlayers();
		void update(int playerNr);
		bool hasChanged();
		void setChanged(bool n_changed);
};
