#include "Sound.h"

#include "MoveableObject.h"
#include "TennisPlayer.h"
#include "Network.h"

Sound::Sound(char *filename)
{
	//position - 3 floats, volym - 1 float, ambient - 1 char, resten innehller
	//filnamnet
	soundDataLength = 4 * sizeof(float) + 1 + strlen(filename) + 1;
	soundData = new char[soundDataLength];
	strcpy(soundData + 4 * sizeof(float) + 1, filename);
	
	sound = new Source(filename);
	//sound->setGain(0.6f);
	volume = 1.0;
	sound->setGain(volume);
}

Sound::~Sound()
{
	delete soundData;
}

void 
Sound::setVolume(float vol)
{
	if((vol>1)||(vol<0))
		vol = 1;
		
	volume = vol;
	sound->setGain(volume);
}

void 
Sound::play()
{
	sound->play();
	
	//Lgg hr in ett anrop ver ntverket att detta ljud skall spelas ven hos
	//klienterna skicka med pos hos soundPosition om soundPosition != NULL
	float *soundPosition = (float *)soundData;
	float *soundGain = (float *) &soundData[3 * sizeof(float)];
	char *soundAmbient = &soundData[4 * sizeof(float)];

	sound->getPosition(soundPosition[0], soundPosition[1], soundPosition[2]);
	*soundGain = sound->getGain();
	*soundAmbient = sound->isAmbient();

	sendPlaySound(soundData, soundDataLength);
}

void 
Sound::play_client()
{
	sound->play();
}

void 
Sound::playAtPos(MoveableObject *creator, TennisPlayer *listener)
{
	const dReal *cPosition = dGeomGetPosition(creator->getPhysicsObject());
	
	if(listener != 0)
	{
		const dReal *lPosition = dGeomGetPosition(listener->getPhysicsObject());
		sound->setPosition(
				cPosition[0] - lPosition[0],
				cPosition[1] - lPosition[1],
				cPosition[2] - lPosition[2]);
		
		/*printf("Playing at pos (%f, %f, %f).\n",
				cPosition[0] - lPosition[0],
				cPosition[1] - lPosition[1],
				cPosition[2] - lPosition[2]);*/
	}
	else
	{
		//I servern r listener = 0 s d mste positionen fr ljudet sttas,
		//annars stts allt ljud till att spelas upp p position 0 - mao
		//alla ljud skulle isf sttas till att spelas upp p position 0, 0, 0
		//klienterna skulle inte kunna avgra vilken position ljudet ska spelas
		//upp p p ngot stt
		
		sound->setPosition(
				cPosition[0],
				cPosition[1],
				cPosition[2]);
		
		/*printf("Playing at pos (%f, %f, %f).\n",
				cPosition[0],
				cPosition[1],
				cPosition[2]);*/
		
		//std::cout << "Nu r listener 0!" << std::endl;
		//No position
	}
}

void 
Sound::loop()
{
	sound->setLooping(true);
}

void 
Sound::stopLoop()
{
	sound->stop();
}

openalpp::ref_ptr<Source> 
Sound::getSound()
{
	return sound;
}

void Sound::setAmbient(bool ambientSetting)
{
	sound->setAmbient(ambientSetting);
}
