#ifndef _MT_TENNISPLAYER_
#define _MT_TENNISPLAYER_

#include <osg/Vec3>
#include <vector>
#include "MoveableObject.h"

class Ball;
class PhysicsObject;
class Sound;


class TennisPlayer:public MoveableObject
{
	protected:
		char name[20];
		osg::Vec3 walkVector;
		int hitCount;
		int kills;
		std::vector<Ball *> ballList;
		Sound *runningSound;
		Sound *hitBallSound;
		Sound *pickUpBallSound;
		Sound *hitPlayerSound;
		Sound *tackleSound;
		
		int runCount;
		int tackleCount;
		bool active;

	public:
		TennisPlayer(PhysicsObject *n_physicsObject, osg::MatrixTransform *n_graphicsObject);
		virtual ~TennisPlayer();
		/*
		void swingRacket();
		void serve();
		void aim();
		void pickUpBall(Ball *ball);
		void pickUpRacket(Racket *racket);
		void pickUpDrink(Drink *drink);
		*/
		void setName(char* name);
		void hitBall(Ball *ball);
		void move(osg::Vec3 walkVector);
		void collision(MoveableObject *mo, dContact thisContact);
		void kill();
		TennisPlayer *asTennisPlayer(){return this;};
		int getHits(){return hitCount;};
		int getKills(){return kills;};
		char *getName(){return name;};
		void setHits(int n_hits){hitCount = n_hits;};
		void setKills(int n_kills){kills = n_kills;};

		int getBallCount(void);
		void pickUpBall(Ball *ball);
		void shootBall(osg::Vec3 direction);
		//void hitSound(TennisPlayer *listener);
		void activate(bool val);
		std::vector<Ball *> *getBallList(){return &ballList;};
};

#endif
