#ifndef _MT_WORLD_
#define _MT_WORLD_

#include <ode/ode.h>
#include <iostream>

#include "WorldObject.h"
#include "MoveableObject.h"
class ScoreBoard;

class World
{
	protected:
		dWorldID physicsWorld;
		dSpaceID physicsSpace;
		dJointGroupID collisionGroup;
		int playerNr;
		ScoreBoard *scoreBoard;
				
	public:
		WorldObject **worldObjects;
		int	numWorldObjects;
		MoveableObject **moveableObjects;
		int	numMoveableObjects;
		
		void setScoreBoard(ScoreBoard *sb){scoreBoard = sb;};
		ScoreBoard *getScoreBoard(){return scoreBoard;};
		
		World();
		~World();
		
		dWorldID getPhysicsWorld();
		dSpaceID getPhysicsSpace();
		dJointGroupID getPhysicsGroup();
		
		int getNumWorldObjects(void);
		WorldObject *getWorldObject(int index);
		WorldObject **getWorldObjects(void);
		
		int getNumMoveableObjects(void);
		MoveableObject *getMoveableObject(int index);
		MoveableObject **getMoveableObjects(void);
		
		WorldObject *findWorldObject(dGeomID compPhysicsObject);
		MoveableObject *findMoveableObject(dGeomID compPhysicsObject);

		void stepPhysics(void);
		
		void setPlayerNr(int pn);
		int getPlayerNr();		
		
		dJointGroupID getCollisionGroup(void) { return collisionGroup; };
		
		void updateBallColumns(void);
		void setListener();
};

void collisionCallback(void *data, dGeomID physicsObject0, dGeomID physicsObject1);

#endif
