#include "WorldObject.h"
#include "Ball.h"

WorldObject::WorldObject(PhysicsObject *n_physicsObject, osg::MatrixTransform *n_graphicsObject) : scale()
{
	physicsObject = n_physicsObject;
	graphicsObject = n_graphicsObject;
	scale = graphicsObject->getMatrix().getScale();
	parent = graphicsObject->getParent(0);
	listener = 0;
	friction = 200;
	bounce = 0.4;
};

WorldObject::~WorldObject()
{
	dGeomDestroy(physicsObject->getObject());
}

void WorldObject::setBounce(float n_bounce)
{
	bounce = n_bounce;
};
float WorldObject::getBounce()
{
	return bounce;
};
void WorldObject::setFriction(float n_friction)
{
	friction = n_friction;
};
float WorldObject::getFriction()
{
	return friction;
};

void WorldObject::disableVisibility(void)
{
	unsigned int childIndex = parent->getChildIndex(graphicsObject);
	if(childIndex < parent->getNumChildren())
		parent->removeChild(childIndex);
}

void WorldObject::enableVisibility(void)
{
	unsigned int childIndex = parent->getChildIndex(graphicsObject);
	if(childIndex == parent->getNumChildren())
		parent->addChild(graphicsObject);

}


dGeomID 
WorldObject::getPhysicsObject()
{
	return physicsObject->getObject();
}

void 
WorldObject::setListener(TennisPlayer *a_listener)
{
	listener = a_listener;
}

