#ifndef _MT_WORLDOBJECT_
#define _MT_WORLDOBJECT_

#include <ode/ode.h>
#include <osg/MatrixTransform>

#include "PhysicsObject.h"
class Ball;
class TennisPlayer;

class WorldObject
{
	protected:
		PhysicsObject *physicsObject;
		osg::MatrixTransform *graphicsObject;
		osg::Group *parent;
		osg::Vec3 scale;
		float bounce;
		float friction;
		TennisPlayer *listener;
		
	public:

		WorldObject(PhysicsObject *n_physicsObject, osg::MatrixTransform *n_graphicsObject);
		virtual ~WorldObject();

		dGeomID getPhysicsObject();
		osg::MatrixTransform *getGraphicsObject(){return graphicsObject;};

		void setBounce(float n_bounce);
		void setFriction(float n_friction);
		float getBounce();
		float getFriction();
		virtual Ball *asBall(){return 0;};
		virtual TennisPlayer *asTennisPlayer(){return 0;};
		void setListener(TennisPlayer *listener);
		
		void disableVisibility(void);
		void enableVisibility(void);
};

#endif
